// Upgrade NOTE: replaced '_Object2World' with 'unity_ObjectToWorld'
// Upgrade NOTE: replaced 'mul(UNITY_MATRIX_MVP,*)' with 'UnityObjectToClipPos(*)'

// Upgrade NOTE: replaced '_Object2World' with '_Object2World'

// define Z_TEXTURE_CHANNELS 4
// define Z_MESH_ATTRIBUTES UV3
// Important!  This is a generated file, any changes will be overwritten
// when the _SfTexBlendSrc suffixed version of this shader is modified.


Shader "Polybrush/TriPlanar Blend Legacy" {
    Properties {
        _Texture1 ("Texture 1", 2D) = "white" {}
        _Texture2 ("Texture 2", 2D) = "white" {}
        
        _Texture3 ("Texture 3", 2D) = "white" {}
        _Texture4 ("Texture 4", 2D) = "white" {}
    }
    SubShader {
        Tags {
            "RenderType"="Opaque"
        }
        Pass {
            Name "FORWARD"
            Tags {
                "LightMode"="ForwardBase"
            }
            
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDBASE
            #define SHOULD_SAMPLE_SH ( defined (LIGHTMAP_OFF) && defined(DYNAMICLIGHTMAP_OFF) )
            #define _GLOSSYENV 1
            #include "UnityCG.cginc"
            #include "AutoLight.cginc"
            #include "Lighting.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #pragma multi_compile_fwdbase_fullshadows
            #pragma multi_compile LIGHTMAP_OFF LIGHTMAP_ON
            #pragma multi_compile DIRLIGHTMAP_OFF DIRLIGHTMAP_COMBINED DIRLIGHTMAP_SEPARATE
            #pragma multi_compile DYNAMICLIGHTMAP_OFF DYNAMICLIGHTMAP_ON
            #pragma multi_compile_fog
            #pragma exclude_renderers gles3 metal d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform sampler2D _Texture1; uniform float4 _Texture1_ST;
            uniform sampler2D _Texture2; uniform float4 _Texture2_ST;
            uniform sampler2D _Texture3; uniform float4 _Texture3_ST;
            
            uniform sampler2D _Texture4; uniform float4 _Texture4_ST;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float4 tangent : TANGENT;
                float4 texcoord1 : TEXCOORD1;
                float4 texcoord2 : TEXCOORD2;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float4 uv1 : TEXCOORD0;
                float4 uv2 : TEXCOORD1;
                float4 posWorld : TEXCOORD2;
                float3 normalDir : TEXCOORD3;
                float3 tangentDir : TEXCOORD4;
                float3 bitangentDir : TEXCOORD5;
                LIGHTING_COORDS(6,7)
                UNITY_FOG_COORDS(8)
                #if defined(LIGHTMAP_ON) || defined(UNITY_SHOULD_SAMPLE_SH)
                    float4 ambientOrLightmapUV : TEXCOORD9;
                #endif
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv1 = v.texcoord1;
                o.uv2 = v.texcoord2;
                #ifdef LIGHTMAP_ON
                    o.ambientOrLightmapUV.xy = v.texcoord1.xy * unity_LightmapST.xy + unity_LightmapST.zw;
                    o.ambientOrLightmapUV.zw = 0;
                #elif UNITY_SHOULD_SAMPLE_SH
                #endif
                #ifdef DYNAMICLIGHTMAP_ON
                    o.ambientOrLightmapUV.zw = v.texcoord2.xy * unity_DynamicLightmapST.xy + unity_DynamicLightmapST.zw;
                #endif
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.tangentDir = normalize( mul( unity_ObjectToWorld, float4( v.tangent.xyz, 0.0 ) ).xyz );
                o.bitangentDir = normalize(cross(o.normalDir, o.tangentDir) * v.tangent.w);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = UnityObjectToClipPos(v.vertex );
                UNITY_TRANSFER_FOG(o,o.pos);
                TRANSFER_VERTEX_TO_FRAGMENT(o)
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
                float3x3 tangentTransform = float3x3( i.tangentDir, i.bitangentDir, i.normalDir);
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float3 viewReflectDirection = reflect( -viewDirection, normalDirection );
                float3 lightDirection = normalize(_WorldSpaceLightPos0.xyz);
                float3 lightColor = _LightColor0.rgb;
////// Lighting:
                float attenuation = LIGHT_ATTENUATION(i);
                float3 attenColor = attenuation * _LightColor0.xyz;
/////// GI Data:
                UnityLight light;
                #ifdef LIGHTMAP_OFF
                    light.color = lightColor;
                    light.dir = lightDirection;
                    light.ndotl = LambertTerm (normalDirection, light.dir);
                #else
                    light.color = half3(0.f, 0.f, 0.f);
                    light.ndotl = 0.0f;
                    light.dir = half3(0.f, 0.f, 0.f);
                #endif
                UnityGIInput d;
                d.light = light;
                d.worldPos = i.posWorld.xyz;
                d.worldViewDir = viewDirection;
                d.atten = attenuation;
                #if defined(LIGHTMAP_ON) || defined(DYNAMICLIGHTMAP_ON)
                    d.ambient = 0;
                    d.lightmapUV = i.ambientOrLightmapUV;
                #else
                    d.ambient = i.ambientOrLightmapUV;
                #endif
                Unity_GlossyEnvironmentData ugls_en_data;
                ugls_en_data.roughness = 1.0 - 0;
                ugls_en_data.reflUVW = viewReflectDirection;
                UnityGI gi = UnityGlobalIllumination(d, 1, normalDirection, ugls_en_data );
                lightDirection = gi.light.dir;
                lightColor = gi.light.color;
/////// Diffuse:
                float NdotL = max(0.0,dot( normalDirection, lightDirection ));
                float3 directDiffuse = max( 0.0, NdotL) * attenColor;
                float3 indirectDiffuse = float3(0,0,0);
                indirectDiffuse += gi.indirect.diffuse;
                float4 node_1190 = float4(i.uv2.r,i.uv2.g,i.uv2.b,i.uv2.a);
                float3 node_8849 = abs(i.normalDir);
                float3 node_3954 = (node_8849*node_8849);
                float2 node_6565 = float2(i.posWorld.g,i.posWorld.b);
                float4 _MainTex = tex2D(_Texture1,TRANSFORM_TEX(node_6565, _Texture1));
                float2 node_3477 = float2(i.posWorld.r,i.posWorld.b);
                float4 node_3536 = tex2D(_Texture1,TRANSFORM_TEX(node_3477, _Texture1));
                float2 node_311 = float2(i.posWorld.g,i.posWorld.r);
                float4 node_3386 = tex2D(_Texture1,TRANSFORM_TEX(node_311, _Texture1));
                float4 node_5742 = tex2D(_Texture2,TRANSFORM_TEX(node_6565, _Texture2));
                float4 node_4501 = tex2D(_Texture2,TRANSFORM_TEX(node_3477, _Texture2));
                float4 node_2195 = tex2D(_Texture2,TRANSFORM_TEX(node_311, _Texture2));
                float4 node_972 = tex2D(_Texture3,TRANSFORM_TEX(node_6565, _Texture3));
                float4 node_4295 = tex2D(_Texture3,TRANSFORM_TEX(node_3477, _Texture3));
                float4 node_1734 = tex2D(_Texture3,TRANSFORM_TEX(node_311, _Texture3));
                float4 node_7081 = tex2D(_Texture4,TRANSFORM_TEX(node_6565, _Texture4));
                float4 node_3235 = tex2D(_Texture4,TRANSFORM_TEX(node_3477, _Texture4));
                float4 node_9532 = tex2D(_Texture4,TRANSFORM_TEX(node_311, _Texture4));
                float3 diffuseColor = (node_1190.r*(node_3954.r*_MainTex.rgb + node_3954.g*node_3536.rgb + node_3954.b*node_3386.rgb) + node_1190.g*(node_3954.r*node_5742.rgb + node_3954.g*node_4501.rgb + node_3954.b*node_2195.rgb) + node_1190.b*(node_3954.r*node_972.rgb + node_3954.g*node_4295.rgb + node_3954.b*node_1734.rgb) + node_1190.a*(node_3954.r*node_7081.rgb + node_3954.g*node_3235.rgb + node_3954.b*node_9532.rgb));
                float3 diffuse = (directDiffuse + indirectDiffuse) * diffuseColor;
/// Final Color:
                float3 finalColor = diffuse;
                fixed4 finalRGBA = fixed4(finalColor,1);
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
        Pass {
            Name "FORWARD_DELTA"
            Tags {
                "LightMode"="ForwardAdd"
            }
            Blend One One
            
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDADD
            #define SHOULD_SAMPLE_SH ( defined (LIGHTMAP_OFF) && defined(DYNAMICLIGHTMAP_OFF) )
            #define _GLOSSYENV 1
            #include "UnityCG.cginc"
            #include "AutoLight.cginc"
            #include "Lighting.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #pragma multi_compile_fwdadd_fullshadows
            #pragma multi_compile LIGHTMAP_OFF LIGHTMAP_ON
            #pragma multi_compile DIRLIGHTMAP_OFF DIRLIGHTMAP_COMBINED DIRLIGHTMAP_SEPARATE
            #pragma multi_compile DYNAMICLIGHTMAP_OFF DYNAMICLIGHTMAP_ON
            #pragma multi_compile_fog
            #pragma exclude_renderers gles3 metal d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform sampler2D _Texture1; uniform float4 _Texture1_ST;
            uniform sampler2D _Texture2; uniform float4 _Texture2_ST;
            uniform sampler2D _Texture3; uniform float4 _Texture3_ST;
            
            uniform sampler2D _Texture4; uniform float4 _Texture4_ST;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float4 tangent : TANGENT;
                float4 texcoord1 : TEXCOORD1;
                float4 texcoord2 : TEXCOORD2;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float4 uv1 : TEXCOORD0;
                float4 uv2 : TEXCOORD1;
                float4 posWorld : TEXCOORD2;
                float3 normalDir : TEXCOORD3;
                float3 tangentDir : TEXCOORD4;
                float3 bitangentDir : TEXCOORD5;
                LIGHTING_COORDS(6,7)
                UNITY_FOG_COORDS(8)
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv1 = v.texcoord1;
                o.uv2 = v.texcoord2;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.tangentDir = normalize( mul( unity_ObjectToWorld, float4( v.tangent.xyz, 0.0 ) ).xyz );
                o.bitangentDir = normalize(cross(o.normalDir, o.tangentDir) * v.tangent.w);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = UnityObjectToClipPos(v.vertex );
                UNITY_TRANSFER_FOG(o,o.pos);
                TRANSFER_VERTEX_TO_FRAGMENT(o)
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
                float3x3 tangentTransform = float3x3( i.tangentDir, i.bitangentDir, i.normalDir);
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                float3 lightDirection = normalize(lerp(_WorldSpaceLightPos0.xyz, _WorldSpaceLightPos0.xyz - i.posWorld.xyz,_WorldSpaceLightPos0.w));
                float3 lightColor = _LightColor0.rgb;
////// Lighting:
                float attenuation = LIGHT_ATTENUATION(i);
                float3 attenColor = attenuation * _LightColor0.xyz;
/////// Diffuse:
                float NdotL = max(0.0,dot( normalDirection, lightDirection ));
                float3 directDiffuse = max( 0.0, NdotL) * attenColor;
                float4 node_1190 = float4(i.uv2.r,i.uv2.g,i.uv2.b,i.uv2.a);
                float3 node_8849 = abs(i.normalDir);
                float3 node_3954 = (node_8849*node_8849);
                float2 node_6565 = float2(i.posWorld.g,i.posWorld.b);
                float4 _MainTex = tex2D(_Texture1,TRANSFORM_TEX(node_6565, _Texture1));
                float2 node_3477 = float2(i.posWorld.r,i.posWorld.b);
                float4 node_3536 = tex2D(_Texture1,TRANSFORM_TEX(node_3477, _Texture1));
                float2 node_311 = float2(i.posWorld.g,i.posWorld.r);
                float4 node_3386 = tex2D(_Texture1,TRANSFORM_TEX(node_311, _Texture1));
                float4 node_5742 = tex2D(_Texture2,TRANSFORM_TEX(node_6565, _Texture2));
                float4 node_4501 = tex2D(_Texture2,TRANSFORM_TEX(node_3477, _Texture2));
                float4 node_2195 = tex2D(_Texture2,TRANSFORM_TEX(node_311, _Texture2));
                float4 node_972 = tex2D(_Texture3,TRANSFORM_TEX(node_6565, _Texture3));
                float4 node_4295 = tex2D(_Texture3,TRANSFORM_TEX(node_3477, _Texture3));
                float4 node_1734 = tex2D(_Texture3,TRANSFORM_TEX(node_311, _Texture3));
                float4 node_7081 = tex2D(_Texture4,TRANSFORM_TEX(node_6565, _Texture4));
                float4 node_3235 = tex2D(_Texture4,TRANSFORM_TEX(node_3477, _Texture4));
                float4 node_9532 = tex2D(_Texture4,TRANSFORM_TEX(node_311, _Texture4));
                float3 diffuseColor = (node_1190.r*(node_3954.r*_MainTex.rgb + node_3954.g*node_3536.rgb + node_3954.b*node_3386.rgb) + node_1190.g*(node_3954.r*node_5742.rgb + node_3954.g*node_4501.rgb + node_3954.b*node_2195.rgb) + node_1190.b*(node_3954.r*node_972.rgb + node_3954.g*node_4295.rgb + node_3954.b*node_1734.rgb) + node_1190.a*(node_3954.r*node_7081.rgb + node_3954.g*node_3235.rgb + node_3954.b*node_9532.rgb));
                float3 diffuse = directDiffuse * diffuseColor;
/// Final Color:
                float3 finalColor = diffuse;
                fixed4 finalRGBA = fixed4(finalColor * 1,0);
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
        Pass {
            Name "Meta"
            Tags {
                "LightMode"="Meta"
            }
            Cull Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_META 1
            #define SHOULD_SAMPLE_SH ( defined (LIGHTMAP_OFF) && defined(DYNAMICLIGHTMAP_OFF) )
            #define _GLOSSYENV 1
            #include "UnityCG.cginc"
            #include "Lighting.cginc"
            #include "UnityPBSLighting.cginc"
            #include "UnityStandardBRDF.cginc"
            #include "UnityMetaPass.cginc"
            #pragma fragmentoption ARB_precision_hint_fastest
            #pragma multi_compile_shadowcaster
            #pragma multi_compile LIGHTMAP_OFF LIGHTMAP_ON
            #pragma multi_compile DIRLIGHTMAP_OFF DIRLIGHTMAP_COMBINED DIRLIGHTMAP_SEPARATE
            #pragma multi_compile DYNAMICLIGHTMAP_OFF DYNAMICLIGHTMAP_ON
            #pragma multi_compile_fog
            #pragma exclude_renderers gles3 metal d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform sampler2D _Texture1; uniform float4 _Texture1_ST;
            uniform sampler2D _Texture2; uniform float4 _Texture2_ST;
            uniform sampler2D _Texture3; uniform float4 _Texture3_ST;
            
            uniform sampler2D _Texture4; uniform float4 _Texture4_ST;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float4 texcoord1 : TEXCOORD1;
                float4 texcoord2 : TEXCOORD2;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float4 uv1 : TEXCOORD0;
                float4 uv2 : TEXCOORD1;
                float4 posWorld : TEXCOORD2;
                float3 normalDir : TEXCOORD3;
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv1 = v.texcoord1;
                o.uv2 = v.texcoord2;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                o.pos = UnityMetaVertexPosition(v.vertex, v.texcoord1.xy, v.texcoord2.xy, unity_LightmapST, unity_DynamicLightmapST );
                return o;
            }
            float4 frag(VertexOutput i) : SV_Target {
                i.normalDir = normalize(i.normalDir);
                float3 viewDirection = normalize(_WorldSpaceCameraPos.xyz - i.posWorld.xyz);
                float3 normalDirection = i.normalDir;
                UnityMetaInput o;
                UNITY_INITIALIZE_OUTPUT( UnityMetaInput, o );
                
                o.Emission = 0;
                
                float4 node_1190 = float4(i.uv2.r,i.uv2.g,i.uv2.b,i.uv2.a);
                float3 node_8849 = abs(i.normalDir);
                float3 node_3954 = (node_8849*node_8849);
                float2 node_6565 = float2(i.posWorld.g,i.posWorld.b);
                float4 _MainTex = tex2D(_Texture1,TRANSFORM_TEX(node_6565, _Texture1));
                float2 node_3477 = float2(i.posWorld.r,i.posWorld.b);
                float4 node_3536 = tex2D(_Texture1,TRANSFORM_TEX(node_3477, _Texture1));
                float2 node_311 = float2(i.posWorld.g,i.posWorld.r);
                float4 node_3386 = tex2D(_Texture1,TRANSFORM_TEX(node_311, _Texture1));
                float4 node_5742 = tex2D(_Texture2,TRANSFORM_TEX(node_6565, _Texture2));
                float4 node_4501 = tex2D(_Texture2,TRANSFORM_TEX(node_3477, _Texture2));
                float4 node_2195 = tex2D(_Texture2,TRANSFORM_TEX(node_311, _Texture2));
                float4 node_972 = tex2D(_Texture3,TRANSFORM_TEX(node_6565, _Texture3));
                float4 node_4295 = tex2D(_Texture3,TRANSFORM_TEX(node_3477, _Texture3));
                float4 node_1734 = tex2D(_Texture3,TRANSFORM_TEX(node_311, _Texture3));
                float4 node_7081 = tex2D(_Texture4,TRANSFORM_TEX(node_6565, _Texture4));
                float4 node_3235 = tex2D(_Texture4,TRANSFORM_TEX(node_3477, _Texture4));
                float4 node_9532 = tex2D(_Texture4,TRANSFORM_TEX(node_311, _Texture4));
                float3 diffColor = (node_1190.r*(node_3954.r*_MainTex.rgb + node_3954.g*node_3536.rgb + node_3954.b*node_3386.rgb) + node_1190.g*(node_3954.r*node_5742.rgb + node_3954.g*node_4501.rgb + node_3954.b*node_2195.rgb) + node_1190.b*(node_3954.r*node_972.rgb + node_3954.g*node_4295.rgb + node_3954.b*node_1734.rgb) + node_1190.a*(node_3954.r*node_7081.rgb + node_3954.g*node_3235.rgb + node_3954.b*node_9532.rgb));
                o.Albedo = diffColor;
                
                return UnityMetaFragment( o );
            }
            ENDCG
        }
    }
    FallBack "Legacy Shaders/Diffuse"
    CustomEditor "z_BlendMaterialInspector"
}
